
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Stock_movementsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.create(
            {
                id: data.id || undefined,
        
        movement_at: data.movement_at
        ||
        null
            ,
            
        movement_type: data.movement_type
        ||
        null
            ,
            
        quantity: data.quantity
        ||
        null
            ,
            
        unit_cost: data.unit_cost
        ||
        null
            ,
            
        reference: data.reference
        ||
        null
            ,
            
        reason: data.reason
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await stock_movements.setProduct( data.product || null, {
            transaction,
        });
        
        await stock_movements.setSupplier( data.supplier || null, {
            transaction,
        });
        
        await stock_movements.setClient( data.client || null, {
            transaction,
        });
        
        await stock_movements.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return stock_movements;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const stock_movementsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                movement_at: item.movement_at
            ||
            null
            ,
            
                movement_type: item.movement_type
            ||
            null
            ,
            
                quantity: item.quantity
            ||
            null
            ,
            
                unit_cost: item.unit_cost
            ||
            null
            ,
            
                reference: item.reference
            ||
            null
            ,
            
                reason: item.reason
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const stock_movements = await db.stock_movements.bulkCreate(stock_movementsData, { transaction });

        // For each item created, replace relation files
        

        return stock_movements;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const stock_movements = await db.stock_movements.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.movement_at !== undefined) updatePayload.movement_at = data.movement_at;
        
        
        if (data.movement_type !== undefined) updatePayload.movement_type = data.movement_type;
        
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.unit_cost !== undefined) updatePayload.unit_cost = data.unit_cost;
        
        
        if (data.reference !== undefined) updatePayload.reference = data.reference;
        
        
        if (data.reason !== undefined) updatePayload.reason = data.reason;
        
        
        updatePayload.updatedById = currentUser.id;

        await stock_movements.update(updatePayload, {transaction});

        
        
        if (data.product !== undefined) {
            await stock_movements.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.supplier !== undefined) {
            await stock_movements.setSupplier(
              
              data.supplier,
              
              { transaction }
            );
        }
        
        if (data.client !== undefined) {
            await stock_movements.setClient(
              
              data.client,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await stock_movements.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return stock_movements;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of stock_movements) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of stock_movements) {
                await record.destroy({transaction});
            }
        });


        return stock_movements;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.findByPk(id, options);

        await stock_movements.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await stock_movements.destroy({
            transaction
        });

        return stock_movements;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.findOne(
            { where },
            { transaction },
        );

        if (!stock_movements) {
            return stock_movements;
        }

        const output = stock_movements.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.product = await stock_movements.getProduct({
            transaction
        });
        
        
        output.supplier = await stock_movements.getSupplier({
            transaction
        });
        
        
        output.client = await stock_movements.getClient({
            transaction
        });
        
        
        output.user = await stock_movements.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.suppliers,
        as: 'supplier',
        
        where: filter.supplier ? {
          [Op.or]: [
            { id: { [Op.in]: filter.supplier.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.supplier.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.clients,
        as: 'client',
        
        where: filter.client ? {
          [Op.or]: [
            { id: { [Op.in]: filter.client.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.client.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stock_movements',
                        'reference',
                        filter.reference,
                    ),
                };
            }
            
            if (filter.reason) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stock_movements',
                        'reason',
                        filter.reason,
                    ),
                };
            }
            

            
            

            
            if (filter.movement_atRange) {
                const [start, end] = filter.movement_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    movement_at: {
                    ...where.movement_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    movement_at: {
                    ...where.movement_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_costRange) {
                const [start, end] = filter.unit_costRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_cost: {
                    ...where.unit_cost,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_cost: {
                    ...where.unit_cost,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.movement_type) {
                where = {
                    ...where,
                movement_type: filter.movement_type,
            };
            }
            


      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.stock_movements.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'stock_movements',
                        'reference',
                        query,
                    ),
                ],
            };
        }

        const records = await db.stock_movements.findAll({
            attributes: [ 'id', 'reference' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reference', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reference,
        }));
    }

    
};

